Code

Replacing the system call pread() with lseek()/xread()/lseek() sequence.
[git.git] / git-checkout.sh
index eb28b291b6d1b7d77306bb3437b9955671e45d3a..92ec069a3acacc2d12c2c709311969f3d0aa4153 100755 (executable)
@@ -112,7 +112,11 @@ Did you intend to checkout '$@' which can not be resolved as commit?"
                git-ls-tree --full-name -r "$new" "$@" |
                git-update-index --index-info || exit $?
        fi
-       git-checkout-index -f -u -- "$@"
+
+       # Make sure the request is about existing paths.
+       git-ls-files --error-unmatch -- "$@" >/dev/null || exit
+       git-ls-files -- "$@" |
+       git-checkout-index -f -u --stdin
        exit $?
 else
        # Make sure we did not fall back on $arg^{tree} codepath
@@ -142,8 +146,11 @@ fi
 
 [ -z "$branch$newbranch" ] &&
        [ "$new" != "$old" ] &&
-       die "git checkout: to checkout the requested commit you need to specify 
-              a name for a new branch which is created and switched to"
+       die "git checkout: provided reference cannot be checked out directly
+
+  You need -b to associate a new branch with the wanted checkout. Example:
+  git checkout -b <new_branch_name> $arg
+"
 
 if [ "X$old" = X ]
 then
@@ -157,7 +164,7 @@ then
     git-read-tree --reset -u $new
 else
     git-update-index --refresh >/dev/null
-    merge_error=$(git-read-tree -m -u $old $new 2>&1) || (
+    merge_error=$(git-read-tree -m -u --exclude-per-directory=.gitignore $old $new 2>&1) || (
        case "$merge" in
        '')
                echo >&2 "$merge_error"
@@ -168,7 +175,8 @@ else
        git diff-files --name-only | git update-index --remove --stdin &&
        work=`git write-tree` &&
        git read-tree --reset -u $new &&
-       git read-tree -m -u --aggressive $old $new $work || exit
+       git read-tree -m -u --aggressive --exclude-per-directory=.gitignore $old $new $work ||
+       exit
 
        if result=`git write-tree 2>/dev/null`
        then